<id>
Sticky Shimmy Shuffle
</id>

<version>
beta 2.4
</version>

<mod info>
This mod allows a moderator, Gmod, or Admin to rearrange the order of stickies of a certain board by clicking an arrow beside the thread name in the direction you want it to go.  In this version it, also allows only Gmods or Admins to rearrange the order of the Global Announcements in any board.

Installation
---------------------------
- Mod your files (All 12 files) and upload in ASCII.
- Rebuild Message Index


Compatability
----------------
YaBB2 Only


Version History
------------------
ver 1.0 - Initial beta release
ver 1.1 - Added the ability to rearrange the global announcements too.
ver 1.2 - Just a little something just in case an admin want to be a moderator too.
ver 1.3 - Will open global announcements, no mater what the file name is.
ver 1.4 - Added support for virboard in global announcements AND moved arrows to far right of thread name.
ver 1.4a - Updated for Y2 Final Release
ver 1.5 - Updated for Y2.1, added fix for thread movement after being moved as a sticky, added "Manfred fix", and added precautionary code that makes sure file lock is enabled so that a file cannot be opened while be written to.
ver 2.0 - Updated how stickies are arranged now using a central file to set the order.
ver 2.1 - Fixed an issue of a stickied thread being "restickied" when locked AND an issue that would delete all stickies if all but one stickies is deleted or unstickied
ver 2.2 - Removed the need to upload stickies.txt and added the ability to rebuild stickies.txt when rebuilding the message index.  Also add Jet Li's spacer.
ver 2.3 - Fixed double sticky issue when replying.
ver 2.4 - Fixed an issue of unsticky thread that still stickied AND move thread go to sticky section. Fix delete Sticky thread, last thread geht sticky section.

Comments
------------------'
- I would like to thank Manfred for coming up with the display "fix".  It has been included here because there seemed to be some interest in making things look like the default YaBB.  Although I didn't think things were broken, I still greatly appreciate Manfred's time and effort in this.
-This new version does not edit any board files like the previous version, allowing this to unistall very cleanly.
</mod info>

<author>
astro-pilot
</author>

<homepage>

</homepage>

<edit file>
Admin/Admin.pl
</edit file>

<search for>
		my $thisboard = $thisthread[0];
</search for>

<add after>
		if ($thisthread[10] =~ /(a|s)/) {&Sticky_Add_Del("add",$thisboard,$thisthread[2]);} ### Sticky Shimmy Shuffle mod ###
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$sss_mod = "Sticky Shimmy Shuffle|astro-pilot|This mod allows a moderator, Gmod, or Admin to rearrange the order of stickies of a certain board by clicking an arrow beside the thread name in the direction you want it to go. In this version it, also allows only Gmods or Admins to rearrange the order of the Global Announcements in any board.|2.4|07/24/06";
	push (@installed_mods, "$sss_mod");
</add before>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
	for ($i = 0; $i <= $threadcount; $i++) {
		my @array        = split(/\|/, $threadlist[$i]);
		my $threadstatus = pop(@array);                    #get only status
		my $mnum         = shift(@array);                  # get only number
		undef @array;
		if ($threadstatus =~ /s/i) {
			unless(!$iamadmin && !$iamgmod && !$iammod && $threadstatus =~ /h/i) {
				$stickythreadlist[$countsticky] = $threadlist[$i];
				$countsticky++;
			}
		} else {
			$nostickythreadlist[$countnosticky] = $threadlist[$i];
			$countnosticky++;
		}
	}
</search for>

<add after>
	### Sticky Shimmy Shuffle mod ###
	require "$vardir/stickies.txt";
	if ($annboard ne $currentboard) {@announcements = split (/\|/ , $stickies{$annboard});}
	my @stickys = split (/\|/ , $stickies{$currentboard});
	my @both = (@announcements, @stickys);
	if ($annboard eq $currentboard) {@stickythreadlist = @nostickythreadlist;}
	foreach (@stickythreadlist){
		my ($stooky) = split(/\|/, $_);
		$stkyindex{$stooky} = $_;
	}
	foreach (@both) {
		push (@orderedsticky, $stkyindex{$_});
	}
	if ($annboard eq $currentboard) {@threadlist = @orderedsticky;}
	else {@stickythreadlist = @orderedsticky;}
	### Sticky Shimmy Shuffle mod end ###
</add after>

<search for>
		elsif ($mstate =~ /s/i && $mstate !~ /h/i) { $threadclass = 'sticky'; }
		elsif ($mstate =~ /a/i && $mstate !~ /h/i) { $threadclass = 'announcement'; }
</search for>

<add after>
		### Sticky Shimmy Shuffle mod ###
		my $stickdir;
		if ($iammod || $iamadmin || $iamgmod) {
		if ($threadclass eq "sticky" || $threadclass eq "stickylock"){$stickdir = qq~&nbsp;&nbsp;<a href="$scripturl?action=rearrsticky;board=$currentboard;num=$mnum;direction=up"><font size="3"><b>&uarr;</b></font></a><a href="$scripturl?action=rearrsticky;board=$currentboard;num=$mnum;direction=down"><font size="3"><b>&darr;</b></font> </a>~;}
		elsif (($threadclass eq "announcement") && ($iamadmin || $iamgmod)){$stickdir = qq~&nbsp;&nbsp;<a href="$scripturl?action=rearrsticky;board=$annboard;num=$mnum;direction=up;oldboard=$currentboard;"><font size="3"><b>&uarr;</b></font></a><a href="$scripturl?action=rearrsticky;board=$annboard;num=$mnum;direction=down;oldboard=$currentboard;"><font size="3"><b>&darr;</b></font> </a>~;}}
		### Sticky Shimmy Shuffle Mod end###
</add after>

<search for>
			$mpoll = qq~<b>$messageindex_polltxt{'15'}: </b>~;
</search for>

<replace>
			$mpoll = qq~<b>$messageindex_polltxt{'15'}:&nbsp;</b>~; ### Sticky Shimmy Shuffle mod ###
</replace>

<search for>
			$pages .= qq~ <a href="$scripturl?num=$mnum/$i#$i">$endpage</a>~;
			$pages = qq~<br /><span class="small">&#171; $messageindex_txt{'139'} $pages <a href="$scripturl?num=$mnum;start=all">$pidtxt{'01'}</a> &#187;</span>~;
</search for>

<replace>
			$pages .= qq~ <a href="$scripturl?num=$mnum/$i#$i">$endpage</a>~;
			$pages = qq~&nbsp;<span class="small">&#171; $messageindex_txt{'139'}: $pages <a href="$scripturl?num=$mnum;start=all">$pidtxt{'01'}</a> &#187;</span>~; ### Sticky Shimmy Shuffle mod ###
</replace>

<search for>
			$pages =~ s/\n\Z//;
			$pages = qq~<br /><span class="small">&#171; $messageindex_txt{'139'} $pages <a href="$scripturl?num=$mnum;start=all">$pidtxt{'01'}</a> &#187;</span>~;
</search for>

<replace>
			$pages =~ s/\n\Z//;
			$pages = qq~&nbsp;<span class="small">&#171; $messageindex_txt{'139'}: $pages <a href="$scripturl?num=$mnum;start=all">$pidtxt{'01'}</a> &#187;</span>~; ### Sticky Shimmy Shuffle mod ###
</replace>

<search for>
			$msublink = qq~<a href="$scripturl?num=$mnum">$msub</a>~;
</search for>

<replace>
			$msublink = qq~<table width="100%" cellborder="0" cellpadding="0" cellspacing="0"><tr><td><a href="$scripturl?num=$mnum">$msub</a></td><td align="right"><font size="1">$stickdir</font></td></tr></table>~; ### Sticky Shimmy Shuffle mod ###
</replace>

<search for>
			$msublink = qq~<a href="$scripturl?virboard=$currentboard;num=$mnum">$msub</a>~;
</search for>

<replace>
			$msublink = qq~<table width="100%" cellborder="0" cellpadding="0" cellspacing="0"><tr><td><a href="$scripturl?virboard=$currentboard;num=$mnum">$msub</a></td><td align="right"><font size="1">$stickdir</font></td></tr></table>~; ### Sticky Shimmy Shuffle mod ###
</replace>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
	if ($tstate !~ /a/i) {
		$tstate = "0$thestatus";
	}
</search for>

<replace>
	if ($tstate !~ /a/i) {
		if ($tstate !~ /s/i && $thestatus =~ /s/i && $postid == 0) {&Sticky_Add_Del("add",$currentboard,$threadid);} ### Sticky Shimmy Shuffle mod ###
		if ($tstate =~ /s/i && $thestatus !~ /s/i && $postid == 0) {&Sticky_Add_Del("del",$currentboard,$threadid);} ### Sticky Shimmy Shuffle mod ###		
		$tstate = "0$thestatus";
	}
</replace>

<edit file>
Sources/MoveTopic.pl
</edit file>

<search for>
	$toboard = $deleteboard || $FORM{'toboard'};
	if ($toboard =~ m~/~)  { &fatal_error($maintxt{'399'}); }
	if ($toboard =~ m~\\~) { &fatal_error($maintxt{'400'}); }
</search for>

<add after>
	&Sticky_Add_Del("del",$fromboard,$thread); ### Sticky Shimmy Shuffle mod ###
</add after>

<search for>
	truncate FROMBOARD, 0;
	seek FROMBOARD, 0, 0;
	print FROMBOARD @buffer;
	fclose(FROMBOARD);
</search for>

<add after>
	if ($orgstate =~ /s/i) {
	&Sticky_Add_Del("add",$fromboard,$newthreadid); ### Sticky Shimmy Shuffle mod ###
	}

</add after>

<search for>
	if (!$inserted) {
		print TOBOARD $OrigThreadLine;
	}
	fclose(TOBOARD);
	&dumplog($toboard);
</search for>

<add after>
	if ($newstatus =~ /s/i) {
	&Sticky_Add_Del("add",$toboard,$thread); ### Sticky Shimmy Shuffle mod ###
	}
</add after>

<edit file>
Sources/Post.pl
</edit file>

<search for>
	# Mark thread as read for the member.
	&dumplog($currentboard, $date);

	&doaddition;
	if(!$iamguest) { &Recent_Write("incr", $thread, $username); }
</search for>

<add after>
	if ($mstate =~ /(a|s)/ && $newthreadid) {&Sticky_Add_Del("add",$currentboard,$thread);} ### Sticky Shimmy Shuffle mod ###
</add after>

<edit file>
Sources/RemoveTopic.pl
</edit file>

<search for>
		if (($delete ne "" && $iamadmin && ($adminbin || $currentboard eq $binboard)) || $iamgmod || $binboard eq "") {
			$INFO{'moveit'} = 1;
			$INFO{'thread'} = $delete;
			&RemoveThread;
</search for>

<add after>
			&Sticky_Add_Del("del",$currentboard,$delete); ### Sticky Shimmy Shuffle mod ###
</add after>

<search for>
	if (($iamadmin && ($adminbin || $currentboard eq $binboard)) || $binboard eq "") {
		$INFO{'moveit'} = 1;
		$INFO{'thread'} = $delete;
		&RemoveThread;
</search for>

<add after>
		&Sticky_Add_Del("del",$currentboard,$delete); ### Sticky Shimmy Shuffle mod ###
</add after>

<search for>
	if (!$currentboard) {
		&MessageTotals("load", $thread);
		$currentboard = ${$thread}{'board'};
	}
</search for>

<add after>
	&Sticky_Add_Del("del",$currentboard,$thread); ### Sticky Shimmy Shuffle mod ###
</add after>

<edit file>
Sources/SetStatus.pl
</edit file>

<search for>
				if ($mstate =~ /$status/) {
					$yydebug .= " It was '$status'. removing<br />";
					$mstate =~ s/$status//ig;
</search for>

<add after>
					if ($status !=~ /s/i) {
						&Sticky_Add_Del("del",$currentboard,$threadid); ### Sticky Shimmy Shuffle mod ###
					}
</add after>

<search for>
				} else {
					$yydebug .= " It wasn't '$status'. adding<br />";
					$mstate  .= "$status";
</search for>

<add after>
					if ($status =~ /s/i) {
						&Sticky_Add_Del("add",$currentboard,$threadid); ### Sticky Shimmy Shuffle mod ###
					}
</add after>

<edit file>
Sources/SplitSplice.pl
</edit file>

<search for>
	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/, $OldThreadLine);
	$OldThreadLine = qq~$mnum|$msub|$mname|$memail|$tmpdate|$postid|$musername|$micon|$mstate\n~;
	$NewThreadLine = qq~$newthreadid|$tmpsub|$tmpname|$tmpemail|$mdate|$remaining|$tmpusername|$tmpicon|$mstate\n~;

</search for>

<add after>
	if ($mstate =~ /s/i) {&Sticky_Add_Del("add",$currentboard,$newthreadid);} ### Sticky Shimmy Shuffle mod ###
</add after>

<search for>
	fopen(BOARD, ">$boardsdir/$curboard.txt", 1)  || fatal_error("716");
	print BOARD @curmessindex;
	fclose(BOARD);
</search for>

<add after>
	if ($mstate =~ /s/i && $FORM{'newthread'} eq 'new') {&Sticky_Add_Del("add",$newboard,$newthreadid);} ### Sticky Shimmy Shuffle mod ###
</add after>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'sticky', "SetStatus.pl&SetStatus",
</search for>

<add after>
'rearrsticky',"System.pl&Rearrange_Sticky", ### Sticky Shimmy Shuffle mod ###
</add after>

<edit file>
Sources/System.pl
</edit file>

<search for>
1;
</search for>

<add before>
### Sticky Shimmy Shuffle mod
sub Rearrange_Sticky {
	my($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $n, $i, $upstky, $downstky, $stkynum, $stky, @stickies, $oldboard);
	$board = $INFO{'board'};
	$stkynum = $INFO{'num'};
	$direction = $INFO{'direction'};
	$oldboard = $INFO{'oldboard'};
	require "$vardir/stickies.txt";
	@stickies = split (/\|/ , $stickies{$board});
	$n = 0;
	foreach (@stickies){
		if ($_ eq $stkynum) {$stky = $n; last;}
		$n++;
	}
	if ($direction eq "down" && $stky != $#stickies) {
		$i = $stky;
		$i++;
		$downstky = $stickies[$stky];
		$upstky = $stickies[$i];
		$stickies[$stky] = $upstky;
		$stickies[$i] = $downstky;}
	if ($direction eq "up" && $stky != 0) {
		$i = $stky;
		$i--;
		$downstky = $stickies[$i];
		$upstky = $stickies[$stky];
		$stickies[$i] = $upstky;
		$stickies[$stky] = $downstky;}
	if ($oldboard) {$currentboard = $oldboard;}
	$stickies{$board} = join('|', @stickies);
	unless (($direction eq "up" && $stky == 0) || ($direction eq "down" && $stky == $#stickies)){
		fopen (FILE, ">$vardir/stickies.txt");
		foreach my $key (keys %stickies) {
			my $value = $stickies{$key};
			print FILE qq~\$stickies{'$key'} = '$value';\n~;
		}		
		print FILE qq~\n1;~;
		fclose(FILE);}
	$yySetLocation = qq~$scripturl?board=$currentboard;~;
	&redirectexit;
}

sub Sticky_Add_Del {
	my ($stickyaction, $stickyboard, $stickyid) = @_;
	if ($INFO{'action'} eq rebuildmesindex && !$stkyct){
		fopen (FILE, ">$vardir/stickies.txt");
		print FILE qq~\n1;~;
		fclose(FILE);	
	}	
	require "$vardir/stickies.txt";
	@stickies = split (/\|/ , $stickies{$stickyboard});

	if ($stickyaction eq 'add') {
		if ($stkyct) {push (@stickies, $stickyid);}
		else {unshift (@stickies, $stickyid);}
	}
	if ($stickyaction eq 'del' && $stickies{$stickyboard}) {
		for ($stk = 0; $stk < @stickies; $stk++) {
     	   		if ($stickies[$stk] eq $stickyid) {
            			splice( @stickies, $stk, 1);
            			last;
        		}
    		}
	}
	if (!$stickies[0] && $stickyaction eq 'del') { delete ($stickies{$stickyboard});}
	else { $stickies{$stickyboard} = join("|", @stickies); }
	
	fopen (FILE, ">$vardir/stickies.txt");
	foreach my $key (keys %stickies) {
		my $value = $stickies{$key};
		print FILE qq~\$stickies{'$key'} = '$value';\n~;
	}		
	print FILE qq~\n1;~;
	fclose(FILE);
	$stkyct = 1;
}
###End Sticky Shimmy Shuffle mod

</add before>

<edit file>
Templates/default/MessageIndex.template
</edit file>

<search for>
<div style="float: left; width: 95%;"><yabb favorite> <yabb new> <yabb poll><b><yabb subjectlink></b><yabb pages></div>
</search for>

<replace>
<div style="float: left; width: 95%;">
<!-- ### Sticky Shimmy Shuffle mod ### -->
  <table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr>
      <td nowrap width="1%" valign="center"><yabb favorite> <yabb new>&nbsp;<yabb poll></td>
      <td nowrap width="99%" valign="center"><b><yabb subjectlink></b></td>
    </tr>
    <tr>
      <td width="100%" colspan="2" valign="center"><yabb pages></td>
    </tr>
  </table>
</div>
<!-- ### Sticky Shimmy Shuffle mod ### -->

</replace>